from fake_useragent import UserAgent
import requests
from lxml import etree
from time import sleep

def get_html(url):
    '''
    :param url:要爬取的地址
    :return: 返回url
    '''
    headers = {'User-Agent':UserAgent().chrome}
    resp = requests.get(url,headers=headers)
    sleep(2)
    if resp.status_code == 200:
        resp.encoding = 'utf-8'
        return resp.text
    else:
        return None


def parse_list(html):
    '''
    :param html:传递进来一个有电影列表的html
    :return: 返回一个电影列表的url
    '''
    e = etree.HTML(html)
    list_url = ['https:{}'.format(url) for url in e.xpath('//li/div/h4/a/@href')]
    return list_url

def parse_index(html):
    '''
    :param html:传递进来一个有电影信息的html
    :return: 返回已经提取好的电影信息
    '''
    e = etree.HTML(html)
    name = e.xpath('//h1/em/text()')
    type = e.xpath('//div/p/span[@class="blue"]/text()')
    actors = e.xpath('//h1/span/a/text()')
    actors = format_data(actors)
    return {'name':name,'type':type,'actors':actors}

def format_data(actors):
    actors_set = set()
    for actor in actors:
        actors_set.add(actor.strip())
    return actors_set

def main():
    num = int(input('请输入要获取多少页:'))
    for page in range(num):
        url = 'https://www.qidian.com/rank/yuepiao?page={}'.format(page)
        list_html = get_html(url)
        list_url = parse_list(list_html)
        for url in list_url:
            info_html = get_html(url)
            movie = parse_index(info_html)
            print(movie)


if __name__ == '__main__':
    main()